# Learning

Here's a list of other resources for learning about Phoenix and some of the projects it depends on.

## Phoenix

#### Books
- [Programming Phoenix](https://pragprog.com/book/phoenix/programming-phoenix) (print and ebook)

#### Online Resources
- [The Phoenix Project](https://github.com/phoenixframework/phoenix)
- [Official Documentation](https://hexdocs.pm/phoenix/) (current stable release)

#### Videos
Phoenix author Chris McCord's videos covering the roadmap to Phoenix 1.0 and an overview of the current state of Phoenix.
- [Phoenix Takes Flight](http://www.chrismccord.com/blog/2015/05/09/elixirconfeu-keynote-phoenix-takes-flight/), Chris McCord
- [Phoenix - a framework for the modern web](https://vimeo.com/131633172), Chris McCord

## Plug
The Elixir middleware layer that Phoenix makes extensive use of.
- [Source Code and Readme](https://github.com/elixir-lang/plug)
- [Documentation](https://hexdocs.pm/plug)

## Ecto
The default data layer for Phoenix.
- [Source Code and Readme](https://github.com/elixir-lang/ecto)
- [Documentation](https://hexdocs.pm/ecto/)

## Phoenix HTML
The project which contains many HTML helper functions used in Phoenix.
- [Source Code and Readme](https://github.com/phoenixframework/phoenix_html)
- [Documentation](https://hexdocs.pm/phoenix_html/)

## ExUnit
- [Documentation](https://hexdocs.pm/ex_unit/1.5.1/ExUnit.html)

## Cowboy
The webserver Phoenix is based on.
- [Source Code and Readme](https://github.com/ninenines/cowboy)
- [User Guides](http://ninenines.eu/docs/en/cowboy/1.0/guide/)
- [Manual/Function Reference](http://ninenines.eu/docs/en/cowboy/1.0/manual/)

## EEx
The default templating system for Phoenix.
- [Source Code and Readme](https://github.com/elixir-lang/elixir)
- [Documentation](https://hexdocs.pm/eex/1.5.1/EEx.html)
